-- awesome 3 configuration file

-- Include awesome library, with lots of useful function!
require("awful")
require("tabulous")
require("beautiful")
require("wicked")
--require('naughty')
--require('eminent')

--[[{{{ 'Beautiful' theme settings
-- Font
beautiful.font = "sans 8"

-- Background
beautiful.bg_normal = '#222222'
beautiful.bg_focus = '#285577'
beautiful.bg_sbfocus = '#113355'
beautiful.bg_urgent = '#A10000'

-- Foreground
beautiful.fg_normal = '#999999'
beautiful.fg_focus = '#ffffff'
beautiful.fg_urgent = '#ffffff'

-- Border
--beautiful.border_width = 2
beautiful.border_normal = '#333333'
beautiful.border_focus = '#4C7899'
beautiful.border_marked = '#91231c'

-- }}}
]]

-- volumewidget{
-- Volume
--volicon = widget({ type = "textbox", name = "volicon", align = "right" })
--volicon.text = "<bg image=\"/home/stxza/.config/awesome/icons/volume.png\" resize=\"true\"/>"
volumewidget = widget({ type = "progressbar", name = "volumewidget",  align = "right" })
--volumewidget = widget({ type = "textbox", name = "volumewidget",  align = "right" })
volumewidget.width = 50
volumewidget.height = 0.63
volumewidget.ticks_count = 15
wicked.register(volumewidget, "function", function (widget, args)
    local f = io.popen("amixer get PCM | grep Left: | cut -f 2 -d [ | cut -d% -f1")
    local l = f:read()
    f:close()
    return l
end, 7, "volume")
volumewidget:mouse_add(mouse({ }, 1, function () awful.spawn(terminal .. " -T Alsamixer -e alsamixer") end))
volumewidget:mouse_add(mouse({ }, 4, function () awful.spawn("amixer set PCM 2%+") end))
volumewidget:mouse_add(mouse({ }, 5, function () awful.spawn("amixer set PCM 2%-") end))


-- }

-- Execute command and return its output. You probably won't only execute commands with one
-- line of output
function execute_command(command)
   local fh = io.popen(command)
   local str = ""
   for i in fh:lines() do
      str = str .. i
   end
   io.close(fh)
   return str
end




-- {{{ Variable definitions
-- This is a file path to a theme file which will defines colors.
theme_path = "/home/xzap/.config/awesome/themes/tt"

-- This is used later as the default terminal to run.
terminal = "urxvt"

-- Default modkey.
-- Usually, Mod4 is the key with a logo between Control and Alt.
-- If you do not like this or do not have such a key,
-- I suggest you to remap Mod4 to another key using xmodmap or other tools.
-- However, you can use another modifier like Mod1, but it may interact with others.
modkey = "Mod4"

-- Table of layouts to cover with awful.layout.inc, order matters.
layouts =
{
    "tile",
    "tileleft",
    "tilebottom",
    "tiletop",
    "fairh",
    "fairv",
    "magnifier",
    "max",
    "spiral",
    "dwindle",
    "floating"
}

-- Table of clients that should be set floating. The index may be either
-- the application class or instance. The instance is useful when running
-- a console app in a terminal like (Music on Console)
--    x-terminal-emulator -name mocp -e mocp
floatapps =
{
    -- by class
["下载"] = true,
    ["urxvtcnotify"] = true,
    ["totem"] = true,
    ["audacious"] = true,
    ["wine"] = true,
    ["qq"] = true,
    ["gmplayer"] = true,
    ["smplayer"] = true,
    ["MPlayer"] = true,
    ["pinentry"] = true,
    ["gimp"] = true,
["gmpc"] = true,
    -- by instance
    ["mocp"] = true
}

-- Applications to be moved to a pre-defined tag by class or instance.
-- Use the screen and tags indices.
apptags =
{
     ["Firefox"] = { screen = 1, tag = 1 },
    -- ["mocp"] = { screen = 2, tag = 4 },
    ["xchat"] = { screen = 1, tag = 8 },
    ["qq"] = { screen = 1, tag = 9 },
    ["Audacious"] = { screen = 1, tag = 9 },
     ["pcmanfm"] = { screen = 1, tag = 2 },
    ["MPlayer"] = { screen = 1, tag = 6 },
   
}
-- Highlight statusbar of focussed screen on multiple-monitor setups
if screen.count() > 1 then
    settings.statusbar_highlight_focus = {true, 1}
end

-- Define if we want to use titlebar on all applications.
use_titlebar = false
resize_hints = false
menu = 'exe=`dmenu_path | dmenu -b -nb black -nf white -fn "sans-16" $*` && exec $exe'
-- }}}

-- {{{ Initialization
-- Initialize theme (colors).
beautiful.init(theme_path)

-- Register theme in awful.
-- This allows to not pass plenty of arguments to each function
-- to inform it about colors we want it to draw.
awful.beautiful.register(beautiful)

-- Uncomment this to activate autotabbing
-- tabulous.autotab_start()
-- }}}

-- {{{ Tags
-- Define tags table.
tags = {}
for s = 1, screen.count() do
    -- Each screen has its own tag table.
    tags[s] = {}
    -- Create 9 tags per screen.
    for tagnumber = 1, 9 do
        tags[s][tagnumber] = tag({ name = tagnumber, layout = layouts[1] })
        -- Add tags to screen one by one
        tags[s][tagnumber].screen = s
    end
    -- I'm sure you want to see at least one tag.
    tags[s][1].selected = true
end
-- }}}

-- {{{ Statusbar
-- Create a taglist widget
mytaglist = widget({ type = "taglist", name = "mytaglist" })
mytaglist:mouse_add(mouse({}, 1, function (object, tag) awful.tag.viewonly(tag) end))
mytaglist:mouse_add(mouse({ modkey }, 1, function (object, tag) awful.client.movetotag(tag) end))
mytaglist:mouse_add(mouse({}, 3, function (object, tag) tag.selected = not tag.selected end))
mytaglist:mouse_add(mouse({ modkey }, 3, function (object, tag) awful.client.toggletag(tag) end))
mytaglist:mouse_add(mouse({ }, 4, awful.tag.viewnext))
mytaglist:mouse_add(mouse({ }, 5, awful.tag.viewprev))
mytaglist.label = awful.widget.taglist.label.all

-- Create a tasklist widget
mytasklist = widget({ type = "tasklist", name = "mytasklist" })
mytasklist:mouse_add(mouse({ }, 1, function (object, c) client.focus = c; c:raise() end))
mytasklist:mouse_add(mouse({ }, 4, function () awful.client.focusbyidx(1) end))
mytasklist:mouse_add(mouse({ }, 5, function () awful.client.focusbyidx(-1) end))
mytasklist.label = awful.widget.tasklist.label.currenttags

-- Create a textbox widget
mytextbox = widget({ type = "textbox", name = "mytextbox", align = "right" })
-- Set the default text in textbox
mytextbox.text = "<b><small> awesome " .. AWESOME_VERSION .. " </small></b>"
mypromptbox = widget({ type = "textbox", name = "mypromptbox", align = "left" })

-- Create an iconbox widget
--myiconbox = widget({ type = "textbox", name = "myiconbox", align = "left" })
--myiconbox.text = "<bg image=\"/usr/share/awesome/icons/awesome16.png\" resize=\"true\"/>"

-- Create a systray
mysystray = widget({ type = "systray", name = "mysystray", align = "right" })

-- Create an iconbox widget which will contains an icon indicating which layout we're using.
-- We need one layoutbox per screen.
mylayoutbox = {}
for s = 1, screen.count() do
    mylayoutbox[s] = widget({ type = "textbox", name = "mylayoutbox", align = "right" })
    mylayoutbox[s]:mouse_add(mouse({ }, 1, function () awful.layout.inc(layouts, 1) end))
    mylayoutbox[s]:mouse_add(mouse({ }, 3, function () awful.layout.inc(layouts, -1) end))
    mylayoutbox[s]:mouse_add(mouse({ }, 4, function () awful.layout.inc(layouts, 1) end))
    mylayoutbox[s]:mouse_add(mouse({ }, 5, function () awful.layout.inc(layouts, -1) end))
    mylayoutbox[s].text = "<bg image=\"/usr/share/awesome/icons/layouts/tilew.png\" resize=\"true\"/>"
end

-- Create a statusbar for each screen and add it
mystatusbar = {}
for s = 1, screen.count() do
    mystatusbar[s] = statusbar({ position = "top", name = "mystatusbar" .. s,height="18",
                                 fg = beautiful.fg_normal, bg = beautiful.bg_normal })
    -- Add widgets to the statusbar - order matters
    mystatusbar[s]:widgets({
        mytaglist,
        mytasklist,
        --myiconbox,
        mypromptbox,
        mytextbox,
        mylayoutbox[s],
        volumewidget,

         s == 1 and mysystray or nil

    })
    mystatusbar[s].screen = s
end
-- }}}

-- {{{ Mouse bindings
awesome.mouse_add(mouse({ }, 3, function () awful.spawn(terminal) end))
awesome.mouse_add(mouse({ }, 4, awful.tag.viewnext))
awesome.mouse_add(mouse({ }, 5, awful.tag.viewprev))
-- }}}

-- {{{ Key bindings

-- Bind keyboard digits
-- Compute the maximum number of digit we need, limited to 9
keynumber = 0
for s = 1, screen.count() do
   keynumber = math.min(9, math.max(#tags[s], keynumber));
end

for i = 1, keynumber do
    keybinding({ modkey }, i,
                   function ()
                       local screen = mouse.screen
                       if tags[screen][i] then
                           awful.tag.viewonly(tags[screen][i])
                       end
                   end):add()
    keybinding({ modkey, "Control" }, i,
                   function ()
                       local screen = mouse.screen
                       if tags[screen][i] then
                           tags[screen][i].selected = not tags[screen][i].selected
                       end
                   end):add()
    keybinding({ modkey, "Shift" }, i,
                   function ()
                       local sel = client.focus
                       if sel then
                           if tags[sel.screen][i] then
                               awful.client.movetotag(tags[sel.screen][i])
                           end
                       end
                   end):add()
    keybinding({ modkey, "Control", "Shift" }, i,
                   function ()
                       local sel = client.focus
                       if sel then
                           if tags[sel.screen][i] then
                               awful.client.toggletag(tags[sel.screen][i])
                           end
                       end
                   end):add()
end

keybinding({ modkey }, "Left", awful.tag.viewprev):add()
keybinding({ modkey }, "Right", awful.tag.viewnext):add()
keybinding({ modkey }, "Escape", awful.tag.history.restore):add()

-- Standard program
keybinding({ modkey }, "Return", function () awful.spawn(terminal) end):add()

keybinding({ modkey, "Control" }, "r", awesome.restart):add()
keybinding({ modkey, "Shift" }, "q", awesome.quit):add()

-- Client manipulation
keybinding({ modkey }, "m", awful.client.maximize):add()
keybinding({ modkey }, "c", function () client.focus:kill() end):add()
keybinding({ modkey }, "j", function () awful.client.focusbyidx(1); client.focus:raise() end):add()
keybinding({ modkey }, "k", function () awful.client.focusbyidx(-1);  client.focus:raise() end):add()
keybinding({ modkey, "Shift" }, "j", function () awful.client.swap(1) end):add()
keybinding({ modkey, "Shift" }, "k", function () awful.client.swap(-1) end):add()
keybinding({ modkey, "Control" }, "j", function () awful.screen.focus(1) end):add()
keybinding({ modkey, "Control" }, "k", function () awful.screen.focus(-1) end):add()
keybinding({ modkey, "Control" }, "space", awful.client.togglefloating):add()
keybinding({ modkey, "Control" }, "Return", function () client.focus:swap(awful.client.master()) end):add()
keybinding({ modkey }, "o", awful.client.movetoscreen):add()
keybinding({ modkey }, "Tab", awful.client.focus.history.previous):add()
keybinding({ modkey }, "u", awful.client.urgent.jumpto):add()
keybinding({ modkey, "Shift" }, "r", function () client.focus:redraw() end):add()

-- Layout manipulation
keybinding({ modkey }, "l", function () awful.tag.incmwfact(0.05) end):add()
keybinding({ modkey }, "h", function () awful.tag.incmwfact(-0.05) end):add()
keybinding({ modkey, "Shift" }, "h", function () awful.tag.incnmaster(1) end):add()
keybinding({ modkey, "Shift" }, "l", function () awful.tag.incnmaster(-1) end):add()
keybinding({ modkey, "Control" }, "h", function () awful.tag.incncol(1) end):add()
keybinding({ modkey, "Control" }, "l", function () awful.tag.incncol(-1) end):add()
keybinding({ modkey }, "space", function () awful.layout.inc(layouts, 1) end):add()
keybinding({ modkey, "Shift" }, "space", function () awful.layout.inc(layouts, -1) end):add()

--volumewidget:mouse_add(mouse({ }, 4, function () awful.spawn("amixer set PCM 2%+") end))
--volumewidget:mouse_add(mouse({ }, 5, function () awful.spawn("amixer set PCM 2%-") end))
keybinding({ modkey }, "Up", function () awful.spawn("amixer set Master 2%+") end):add()
keybinding({ modkey }, "Down", function () awful.spawn("amixer set Master 2%-") end):add()
keybinding({ }, "0xb0", function () awful.spawn("amixer set Master 2%+") end):add()
 keybinding({ }, "0xae", function () awful.spawn("amixer set Master 2%-") end):add()

keybinding({ modkey }, "f", function () awful.spawn("firefox") end):add()
keybinding({ modkey }, "s", function () awful.spawn("stardict") end):add()
keybinding({ modkey }, "p", function () awful.spawn("pcmanfm") end):add()
keybinding({ modkey }, "x", function () awful.spawn("xchat") end):add()

keybinding({ modkey }, "b", function () 
      if mystatusbar[mouse.screen].screen == nil then 
         mystatusbar[mouse.screen].screen = mouse.screen
     else
         mystatusbar[mouse.screen].screen = nil
     end
 end):add()

keybinding({ modkey }, "v", function () 
      if  mystatusbar2[mouse.screen].screen == nil then 
          mystatusbar2[mouse.screen].screen = mouse.screen
     else
        mystatusbar2[mouse.screen].screen = nil
     end
 end):add()

keybinding({ modkey}, "F2", function () awful.spawn(menu) end):add()

-- Prompt
keybinding({ modkey }, "F1", function ()
                                 awful.prompt.run({ prompt = "Run: " }, mypromptbox, awful.spawn, awful.completion.bash,
os.getenv("HOME") .. "/.cache/awesome/history") end):add()
keybinding({ modkey }, "F4", function ()
                                 awful.prompt.run({ prompt = "Run Lua code: " }, mypromptbox, awful.eval, awful.prompt.bash,
os.getenv("HOME") .. "/.cache/awesome/history_eval") end):add()
keybinding({ modkey, "Ctrl" }, "i", function ()
                                        if mypromptbox.text then
                                            mypromptbox.text = nil
                                        else
                                            mypromptbox.text = nil
                                            if client.focus.class then
                                                mypromptbox.text = "Class: " .. client.focus.class .. " "
                                            end
                                            if client.focus.instance then
                                                mypromptbox.text = mypromptbox.text .. "Instance: ".. client.focus.instance .. " "
                                            end
                                            if client.focus.role then
                                                mypromptbox.text = mypromptbox.text .. "Role: ".. client.focus.role
                                            end
                                        end
                                    end):add()

--- Tabulous, tab manipulation
keybinding({ modkey, "Control" }, "y", function ()
    local tabbedview = tabulous.tabindex_get()
    local nextclient = awful.client.next(1)

    if not tabbedview then
        tabbedview = tabulous.tabindex_get(nextclient)

        if not tabbedview then
            tabbedview = tabulous.tab_create()
            tabulous.tab(tabbedview, nextclient)
        else
            tabulous.tab(tabbedview, client.focus)
        end
    else
        tabulous.tab(tabbedview, nextclient)
    end
end):add()

keybinding({ modkey, "Shift" }, "y", tabulous.untab):add()

keybinding({ modkey }, "y", function ()
   local tabbedview = tabulous.tabindex_get()

   if tabbedview then
       local n = tabulous.next(tabbedview)
       tabulous.display(tabbedview, n)
   end
end):add()

-- Client awful tagging: this is useful to tag some clients and then do stuff like move to tag on them
keybinding({ modkey }, "t", awful.client.togglemarked):add()
keybinding({ modkey, 'Shift' }, "t", function ()
    local tabbedview = tabulous.tabindex_get()
    local clients = awful.client.getmarked()

    if not tabbedview then
        tabbedview = tabulous.tab_create(clients[1])
        table.remove(clients, 1)
    end

    for k,c in pairs(clients) do
        tabulous.tab(tabbedview, c)
    end

end):add()

for i = 1, keynumber do
    keybinding({ modkey, "Shift" }, "F" .. i,
                   function ()
                       local screen = mouse.screen
                       if tags[screen][i] then
                           for k, c in pairs(awful.client.getmarked()) do
                               awful.client.movetotag(tags[screen][i], c)
                           end
                       end
                   end):add()
end
-- }}}

--xzap's luncher
-- Create a textbox
mytextbox2 = widget({ type = "textbox", name = "mytextbox2" ,align = "right" })
-- Set text of the textbox
mytextbox2.text ="   FireFox |"
mytextbox2:mouse_add(mouse({ }, 1, function () awful.spawn("firefox") end))
mytextbox3 = widget({ type = "textbox", name = "mytextbox3" ,align = "right" })
mytextbox3.text =" Audacious |"
mytextbox3:mouse_add(mouse({ }, 1, function () awful.spawn("audacious") end))
mytextbox4 = widget({ type = "textbox", name = "mytextbox4" ,align = "right" })
mytextbox4.text =" Thunar |"
mytextbox4:mouse_add(mouse({ }, 1, function () awful.spawn("thunar") end))
mytextbox5 = widget({ type = "textbox", name = "mytextbox5",align = "right"  })
mytextbox5.text =" Gmpc |"
mytextbox5:mouse_add(mouse({ }, 1, function () awful.spawn("gmpc") end))
mytextbox6 = widget({ type = "textbox", name = "mytextbox6",align = "right"  })
mytextbox6.text =" Pcmanfm |"
mytextbox6:mouse_add(mouse({ }, 1, function () awful.spawn("pcmanfm") end))
mytextbox7 = widget({ type = "textbox", name = "mytextbox7",align = "right"  })
mytextbox7.text =" ThunderBird |"
mytextbox7:mouse_add(mouse({ }, 1, function () awful.spawn("thunderbird") end))

mytextbox8 = widget({ type = "textbox", name = "mytextbox8",align = "right"  })
mytextbox8.text =" Update   "
mytextbox8:mouse_add(mouse({ }, 1, function () awful.spawn(terminal .. " -T update -e  sudo apt-get update&&sudo apt-get upgrade") end))
--volumewidget:mouse_add(mouse({ }, 1, function () awful.spawn(terminal .. " -T Alsamixer -e alsamixer") end))
mytextbox9 = widget({ type = "textbox", name = "mytextbox9",align = "right"  })
mytextbox9.text =" Xchat |"
mytextbox9:mouse_add(mouse({ }, 1, function () awful.spawn("xchat") end))
mytextbox2l = widget({ type = "textbox", name = "mytextbox2l" ,align = "left" })
mytextbox2l.text ="<bg image=\"/home/xzap/.config/awesome/icons/music.svg\" resize=\"true\"/>"
mytextbox2l:mouse_add(mouse({ }, 1, function () awful.spawn("mpd&&mpc listall|mpc add") end))
mytextbox2m = widget({ type = "textbox", name = "mytextbox2m" ,align = "left" ,height="2"})
mytextbox2m.text ="<bg image=\"/home/xzap/.config/awesome/icons/play.svg\" resize=\"true\"/ >   "
mytextbox2m:mouse_add(mouse({ }, 1, function () awful.spawn("mpc random&&mpc play") end))
mytextbox3m = widget({ type = "textbox", name = "mytextbox3m" ,align = "left" })
mytextbox3m.text ="<bg image=\"/home/xzap/.config/awesome/icons/next.svg\" resize=\"true\"/>"
mytextbox3m:mouse_add(mouse({ }, 1, function () awful.spawn("mpc next") end))
mytextbox4m = widget({ type = "textbox", name = "mytextbox4m" ,align = "left" })
mytextbox4m.text ="<bg image=\"/home/xzap/.config/awesome/icons/prev.svg\" resize=\"true\"/>"
mytextbox4m:mouse_add(mouse({ }, 1, function () awful.spawn("mpc prev") end))
mytextbox5m = widget({ type = "textbox", name = "mytextbox5m",align = "left"  })
mytextbox5m.text ="<bg image=\"/home/xzap/.config/awesome/icons/stop.svg\" resize=\"true\"/>"
mytextbox5m:mouse_add(mouse({ }, 1, function () awful.spawn("mpc stop") end))
mytextbox6m = widget({ type = "textbox", name = "mytextbox6m",align = "left"  })
mytextbox6m.text ="<bg image=\"/home/xzap/.config/awesome/icons/seach.svg\" resize=\"true\"/>"
mytextbox6m:mouse_add(mouse({ }, 1, function () awful.spawn(terminal .. " -T Lirc -e baidu") end))

mytextbox7m = widget({ type = "textbox", name = "mytextbox7m",align = "left"  })
mytextbox7m.text ="<bg image=\"/home/xzap/.config/awesome/icons/pause.svg\" resize=\"true\"/>"
mytextbox7m:mouse_add(mouse({ }, 1, function () awful.spawn("mpc pause") end))

mytextboxk = widget({ type = "textbox", name = "mytextboxk" ,align = "left" })
mytextboxk.text ="  "
mytextbox99 = widget({ type = "textbox", name = "mytextbox99",align = "left"  })




mytasklist:mouse_add(mouse({ }, 3, function () client.focus:kill() end))
--wicked


--mpd
mpdwidget = widget({
    type = 'textbox',
    name = 'mpdwidget'
})
wicked.register(mpdwidget, wicked.widgets.mpd, 
	function (widget, args)
		   if args[1]:find("volume:") == nil then
		      return ' <span color="white"> '..args[1].."</span>"
		   else
                      return ''
                   end
		end)
--[[Memory 
memwidget = widget({
    type = 'textbox',
    name = 'memwidget'
})

wicked.register(memwidget, wicked.widgets.mem,
    ' <span color="white">Memory:</span> $1 ($2Mb/$3Mb)')
]]


--CPU Usage 
cpuwidget = widget({
    type = 'textbox',
    name = 'cpuwidget',align="right"
})

wicked.register(cpuwidget, wicked.widgets.cpu,
    ' <span color="white">CPU:</span> $1%')
--Filesystem
fswidget = widget({
    type = 'textbox',
    name = 'fswidget'
})

wicked.register(fswidget, wicked.widgets.fs,
    ' <span color="white">FS:</span> ${/ used}/${/ size} (${/ usep} used)', 120)
--vol
volumewidget2 = widget({
    type = 'textbox',
    name = 'volumewidget2'
})

function amixer_volume(format)
   local f = io.popen('amixer get PCM')
   local l = f:lines()
   local v = ''

   for line in l do
       if line:find('Front Left:') ~= nil then
            pend = line:find('%]', 0, true)
            pstart = line:find('[', 0, true)
            v = line:sub(pstart+1, pend)
       end
   end

   f:close()

   return {v}
end

wicked.register(volumewidget2, amixer_volume, "<span color='white'>Volume</span>: $1", 4)
--Network
netwidget = widget({
    type = 'textbox',
    name = 'netwidget',align="right"
})

wicked.register(netwidget, wicked.widgets.net, 
  --  ' <span color="white">NET</span>: ${eth0 down} / ${eth0 up} [ ${eth0 rx} //  ${eth0 tx} ]',nil, nil, 3)
 ' <span color="white">NET</span>: ${eth0 down} / ${eth0 up} ',nil, nil, 3)
-- ,height="16"
-- Create a statusbar

mystatusbar2 = {}
for s = 1, screen.count() do

mystatusbar2[s] = statusbar({ position = "bottom", name = "mystatusbar2".. s,height="18",
                                 fg = beautiful.fg_normal, bg = beautiful.bg_normal})
-- Add widgets to the statusbar
mystatusbar2[s]:widgets({ 

--fswidget,

--memwidget,
mytextbox99,
mytextbox2l,
mytextboxk,
mytextbox4m,
mytextboxk,
mytextbox7m,
mytextboxk,
mytextbox2m,
mytextboxk,
mytextbox5m,
mytextboxk,
mytextbox3m,

mytextboxk,
mytextbox6m,
mytextboxk,

netwidget,

mpdwidget,
volumewidget2,
cpuwidget,
mytextbox2,
--mytextbox3,
--mytextbox4,
mytextbox5,
mytextbox6,
mytextbox7,
--mytextbox9,
--mytextbox8,
--mytextboxk,
mytextboxcc,

-- Add the statusbar on screen #1
       s == 1 and nil
    })
    mystatusbar2[s].screen = s
end


mytextbox99:mouse_add(mouse({ }, 1, function () awful.spawn("amixer set Master 0") end))
mytextbox99:mouse_add(mouse({ }, 4, function () awful.spawn("amixer set Master 2%+") end))
mytextbox99:mouse_add(mouse({ }, 5, function () awful.spawn("amixer set Master 2%-") end))




-- {{{ Hooks
-- Hook function to execute when focusing a client.
function hook_focus(c)
    if not awful.client.ismarked(c) then
        c.border_color = beautiful.border_focus
    end
end

-- Hook function to execute when unfocusing a client.
function hook_unfocus(c)
    if not awful.client.ismarked(c) then
        c.border_color = beautiful.border_normal
    end
end

-- Hook function to execute when marking a client
function hook_marked(c)
    c.border_color = beautiful.border_marked
end

-- Hook function to execute when unmarking a client
function hook_unmarked(c)
    c.border_color = beautiful.border_focus
end

-- Hook function to execute when the mouse is over a client.
function hook_mouseover(c)
    -- Sloppy focus, but disabled for magnifier layout
    if awful.layout.get(c.screen) ~= "magnifier" then
        client.focus = c
    end
end

-- Hook function to execute when a new client appears.
function hook_manage(c)
    -- Set floating placement to be smart!
    c.floating_placement = "smart"
    if use_titlebar then
        -- Add a titlebar
        awful.titlebar.add(c, { modkey = modkey })
    end
    -- Add mouse bindings
    c:mouse_add(mouse({ }, 1, function (c) client.focus = c; c:raise() end))
    c:mouse_add(mouse({ modkey }, 1, function (c) c:mouse_move() end))
    c:mouse_add(mouse({ modkey }, 3, function (c) c:mouse_resize() end))
    -- New client may not receive focus
    -- if they're not focusable, so set border anyway.
    c.border_width = beautiful.border_width
    c.border_color = beautiful.border_normal
    client.focus = c

    -- Check if the application should be floating.
    local cls = c.class
    local inst = c.instance
    if floatapps[cls] then
        c.floating = floatapps[cls]
    elseif floatapps[inst] then
        c.floating = floatapps[inst]
    end

    -- Check application->screen/tag mappings.
    local target
    if apptags[cls] then
        target = apptags[cls]
    elseif apptags[inst] then
        target = apptags[inst]
    end
    if target then
        c.screen = target.screen
        awful.client.movetotag(tags[target.screen][target.tag], c)
    end

    -- Set the windows at the slave,
    -- i.e. put it at the end of others instead of setting it master.
    -- awful.client.setslave(c)

    -- Honor size hints
    c.honorsizehints = true
end

-- Hook function to execute when arranging the screen
-- (tag switch, new client, etc)
function hook_arrange(screen)
    local layout = awful.layout.get(screen)
    if layout then
        mylayoutbox[screen].text =
            "<bg image=\"/usr/share/awesome/icons/layouts/" .. awful.layout.get(screen) .. "w.png\" resize=\"true\"/>"
        else
            mylayoutbox[screen].text = "No layout."
    end

    -- If no window has focus, give focus to the latest in history
    if not client.focus then
        local c = awful.client.focus.history.get(screen, 0)
        if c then client.focus = c end
    end

    -- Uncomment if you want mouse warping
    --[[
    local sel = client.focus
    if sel then
        local c_c = sel:coords()
        local m_c = mouse.coords()

        if m_c.x < c_c.x or m_c.x >= c_c.x + c_c.width or
            m_c.y < c_c.y or m_c.y >= c_c.y + c_c.height then
            if table.maxn(m_c.buttons) == 0 then
                mouse.coords({ x = c_c.x + 5, y = c_c.y + 5})
            end
        end
    end
    ]]
end
-- Autostart
function autostart(dir)
    if not dir then
        do return nil end
    end
    local fd = io.popen("ls -1 -F " .. dir)
    if not fd then
        do return nil end
    end
    for file in fd:lines() do
        local c= string.sub(file,-1)   -- last char
        if c=='*' then  -- executables
            executable = string.sub( file, 1,-2 )
            print("Awesome Autostart: Executing: " .. executable)
            os.execute(dir .. "/" .. executable .. " &") -- launch in bg
        elseif c=='@' then  -- symbolic links
            print("Awesome Autostart: Not handling symbolic links: " .. file)
        else
            print ("Awesome Autostart: Skipping file " .. file .. " not executable.")
        end
    end
    io.close(fd)
end

autostart_dir = os.getenv("HOME") .. "/.config/awesome/autostart"
autostart(autostart_dir)

-- Hook called every second
function hook_timer ()
    -- For unix time_t lovers
    mytextbox.text = " " .. os.date() .. ""
 mytextbox99.text = " " .. execute_command("amixer get Master | grep Mono: | cut -f 2 -d [ | cut -d% -f1") .. "% "
    -- Otherwise use:
    -- mytextbox.text = " " .. os.date() .. " "
end




-- Set up some hooks
awful.hooks.focus.register(hook_focus)
awful.hooks.unfocus.register(hook_unfocus)
awful.hooks.marked.register(hook_marked)
awful.hooks.unmarked.register(hook_unmarked)
awful.hooks.manage.register(hook_manage)
awful.hooks.mouseover.register(hook_mouseover)
awful.hooks.arrange.register(hook_arrange)
awful.hooks.timer.register(1, hook_timer)
awful.hooks.timer.register(1, execute_command)
-- }}}
